
#include <iostream>
#include <fstream>
#include <string>
#include <sstream>
#include <stdio.h>
#include <stdlib.h>
#include <math.h>
#include <vector>
#include <netinet/in.h>

#include "include/i2str.h"

#include "CLHEP/Hist/HBookFile.h"
#include "CLHEP/Hist/HBookHistogram.h"
#include "CLHEP/Hist/HBookTuple.h"

int main()
{
  const int Nch_adc=16*1;
  const int Nch_tdc=8*1;

  /*********** histgram definision *****************/
  HBookFile *hbkfile;
  HepHistogram *h_adc[Nch_adc];
  HepHistogram *h_tdc[Nch_tdc]; 
  HepTuple  *nt_mcp;
  /*************************************************/

  const int datasize = Nch_adc+Nch_tdc+1;

  int data0[datasize];
  int mark;

  //////// input card ////////
  char infile[50];
  cout << " Please input file name \n";
  cin >> infile;
  cout << " input file name == " << infile << "\n";

  int n_event;
  cout << " Please input event data number \n";
  cin >> n_event;
  cout << " input event data number == " <<  n_event << "\n";

  char hfilename[50];	
  cout << " Please input HBOOK file name \n";
  cin >> hfilename;
  cout << " HBOOK file name == " << hfilename << "\n";

  // data file open
  std::ifstream ifs_pr(infile, ios::binary);
  if(!ifs_pr.is_open()){
    cerr << "Error: could not open datafile." << endl;
    exit(1);
  }

  ///////////////////// HBOOK$B$N@k8@(B ///////////////////////
  hbkfile = new HBookFile( hfilename , 14 );  

  ////// Initialize ///////
  for(int i=0;i<datasize;i++) data0[i]=0;
  
  std::string histname; 
  //for(int i=0; i<Nch_adc; i++){
  //  histname = "adc (ch";  histname += i2str(i+1);  histname += ")";
  //  h_adc[i] = hbkfile->histogram(histname.c_str(),adc_bin,adc_min,adc_max,i+101);
  //}
  //for(int i=0; i<ch_tdc.size(); i++){
  //  histname = "tdc (ch";  histname += i2str(i+1);  histname += ")";
  //  h_tdc[i] = hbkfile->histogram(histname.c_str(),tdc_bin,tdc_min,tdc_max,i+201);
  //}

  nt_mcp = hbkfile->ntuple("mcp" ,1);
  std::ostringstream column_name;

  ////////////////// Analysis ////////////////////
  for(int k=0; k<n_event; k++)
  {
    ifs_pr.read((char *)data0, sizeof(int)*(datasize-1));
    ifs_pr.read((char *)&mark, sizeof(int)*1);

    if((k%10000)==0) std::cout << "No. of event = " << k << std::endl;

    //////////// $B%^%9%/(B //////////////
    for(int i=0; i<Nch_adc; i++) data0[i]=(data0[i] & 0x0fff);
    //////////////////////////////////////////// 

//    for(int i=0; i<Nch_adc; i++){
//      h_adc[i]->accumulate(float(data0[i]), 1.0);
//    }
//    for(int n=0; n<Nch_tdc; n++){
//      h_tdc[n]->accumulate(float(data0[n+Nch_adc]), 1.0);
//    }

    for(int i=0; i<Nch_adc; i++){
      column_name.str("");
      column_name << "adc" << i;
      nt_mcp->column(column_name.str().c_str(), int(data0[i]));
    }
    for(int i=0; i<Nch_tdc; i++){
      column_name.str("");
      column_name << "tdc" << i;
      nt_mcp->column(column_name.str().c_str(), int(data0[i+Nch_adc]));
    }
    nt_mcp->column("num", k);

    nt_mcp->dumpData();   
  }
  //end event loop

  hbkfile->write();
  delete hbkfile;
  ifs_pr.close();
  return(0);
}
